#include <cv.h>
#include <stdio.h>

void printData(float data[64][64])
{
	printf("-----\n");
	for(int m=0; m<64; m++) {
		for(int n=0; n<64; n++)
			printf("%f ", data[m][n]);
		printf("\n");
	}
	printf("-----\n");
}

void doSVD(float data[64][64], int type)
{
	CvMat *M = cvCreateMat(64, 64, type);
	for(int m=0; m<64; m++)
		for(int n=0; n<64; n++)
			cvmSet(M, m, n, data[m][n]);

	CvMat *U = cvCreateMat(64, 64, type);
	CvMat *W = cvCreateMat(64, 1, type);
	cvSVD(M, W, U, NULL, CV_SVD_MODIFY_A|CV_SVD_U_T);

	printf("Eigenvalues:");
	for(int i=0; i<64; i++)
		printf(" %f", cvmGet(W, i, 0));
	printf("\n");

	cvReleaseMat(&M);
	cvReleaseMat(&U);
	cvReleaseMat(&W);
}

int main(int argc, char **argv)
{
	float data[64][64];
	FILE *f = fopen("matrix.dat", "r");
	if(!f) return 1;
	fread(data, 64*64*sizeof(float), 1, f);
	fclose(f);
	//printData(data);
	
	// This works
	doSVD(data, CV_64FC1);
	// This doesn't (on x86_64, on 32 bit the result is the same as above)
	doSVD(data, CV_32FC1);
	return 0;
}
